/*
BotV2

Bot API v2

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package botapiv2

import (
	"encoding/json"
	"fmt"
)

// DataSource `output` is special data source, which is available only in actions used as output handlers.
type DataSource string

// List of DataSource
const (
	DataSourceStatic DataSource = "static"
	DataSourceEvent DataSource = "event"
	DataSourceContact DataSource = "contact"
	DataSourceTx DataSource = "tx"
	DataSourceCode DataSource = "code"
	DataSourceSegments DataSource = "segments"
	DataSourceLabels DataSource = "labels"
	DataSourceSession DataSource = "session"
	DataSourceMessage DataSource = "message"
	DataSourceMobileDevice DataSource = "mobile_device"
)

// All allowed values of DataSource enum
var AllowedDataSourceEnumValues = []DataSource{
	"static",
	"event",
	"contact",
	"tx",
	"code",
	"segments",
	"labels",
	"session",
	"message",
	"mobile_device",
}

func (v *DataSource) UnmarshalJSON(src []byte) error {
	var value string
	err := json.Unmarshal(src, &value)
	if err != nil {
		return err
	}
	enumTypeValue := DataSource(value)
	for _, existing := range AllowedDataSourceEnumValues {
		if existing == enumTypeValue {
			*v = enumTypeValue
			return nil
		}
	}

	return fmt.Errorf("%+v is not a valid DataSource", value)
}

// NewDataSourceFromValue returns a pointer to a valid DataSource
// for the value passed as argument, or an error if the value passed is not allowed by the enum
func NewDataSourceFromValue(v string) (*DataSource, error) {
	ev := DataSource(v)
	if ev.IsValid() {
		return &ev, nil
	} else {
		return nil, fmt.Errorf("invalid value '%v' for DataSource: valid values are %v", v, AllowedDataSourceEnumValues)
	}
}

// IsValid return true if the value is valid for the enum, false otherwise
func (v DataSource) IsValid() bool {
	for _, existing := range AllowedDataSourceEnumValues {
		if existing == v {
			return true
		}
	}
	return false
}

// Ptr returns reference to DataSource value
func (v DataSource) Ptr() *DataSource {
	return &v
}

type NullableDataSource struct {
	value *DataSource
	isSet bool
}

func (v NullableDataSource) Get() *DataSource {
	return v.value
}

func (v *NullableDataSource) Set(val *DataSource) {
	v.value = val
	v.isSet = true
}

func (v NullableDataSource) IsSet() bool {
	return v.isSet
}

func (v *NullableDataSource) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableDataSource(val *DataSource) *NullableDataSource {
	return &NullableDataSource{value: val, isSet: true}
}

func (v NullableDataSource) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableDataSource) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}

